/* cypher.c david stafford computer shopper */

#include <stdio.h>
#include <stdlib.h>

#define MULTIPLIER 0x015A4E35L
#define INCREMENT 1

long RandomSeed;

int GetRandomNumber( int Range )
{
RandomSeed = MULTIPLIER*RandomSeed+INCREMENT;

return(RandomSeed%Range);
}

void Cipher(FILE*InFile,FILE*OutFile)
{
int Ch;
while ((Ch=getc(InFile))!=EOF)
  {
    fputc(Ch ^ GetRandomNumber(256),OutFile);
  }
}

void Supervisor( long Key, char *InFileName, char *OutFileName)
{
FILE*InFile, *OutFile;
if((InFile=fopen(InFileName,"rb"))!=NULL)
  {
if((OutFile=fopen(OutFileName,"wb"))!=NULL)
  {
    RandomSeed=Key;
Cipher(InFile,OutFile);
fclose(OutFile);
  }
else
  {
printf("Can't open output file %s\n",OutFileName);
}
fclose (InFile);
}
else
  {
printf("Can't open input file %s\n",InFileName);
}
}

void main(int Argc, char *Argv[])
{
if(Argc==4)
  {
Supervisor(atol(Argv[1]),Argv[2],Argv[3]);
	 }
else
	   {
puts("Cipher- File   encryption/decryption\n");
puts("Usage: cipher_key input_file output_file\n");
puts(" cipher_key is an integer");
puts(" input_file & output_file are the file names\n");
}
}
